upload-pack: Check for NOT_SHALLOW flag before sending a shallow to the client.
[git/gitweb-caching.git] / git-clone.sh
blob8c0a93ebd15399fad6f58fcf315709cb94fd6128
1 #!/bin/sh
3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
5 #
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
9 unset CDPATH
11 die() {
12 echo >&2 "$@"
13 exit 1
16 usage() {
17 die "Usage: $0 [--template=<template_directory>] [--use-immingled-remote] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [--depth <n>] [-n] <repo> [<dir>]"
20 get_repo_base() {
21 (cd "$1" && (cd .git ; pwd)) 2> /dev/null
24 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
25 curl_extra_args="-k"
28 http_fetch () {
29 # $1 = Remote, $2 = Local
30 curl -nsfL $curl_extra_args "$1" >"$2"
33 clone_dumb_http () {
34 # $1 - remote, $2 - local
35 cd "$2" &&
36 clone_tmp="$GIT_DIR/clone-tmp" &&
37 mkdir -p "$clone_tmp" || exit 1
38 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
39 "`git-repo-config --bool http.noEPSV`" = true ]; then
40 curl_extra_args="${curl_extra_args} --disable-epsv"
42 http_fetch "$1/info/refs" "$clone_tmp/refs" ||
43 die "Cannot get remote repository information.
44 Perhaps git-update-server-info needs to be run there?"
45 while read sha1 refname
47 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
48 case "$name" in
49 *^*) continue;;
50 esac
51 if test -n "$use_separate_remote" &&
52 branch_name=`expr "z$name" : 'zheads/\(.*\)'`
53 then
54 tname="remotes/$origin/$branch_name"
55 else
56 tname=$name
58 git-http-fetch -v -a -w "$tname" "$name" "$1/" || exit 1
59 done <"$clone_tmp/refs"
60 rm -fr "$clone_tmp"
61 http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
62 rm -f "$GIT_DIR/REMOTE_HEAD"
65 # Read git-fetch-pack -k output and store the remote branches.
66 copy_refs='
67 use File::Path qw(mkpath);
68 use File::Basename qw(dirname);
69 my $git_dir = $ARGV[0];
70 my $use_separate_remote = $ARGV[1];
71 my $origin = $ARGV[2];
73 my $branch_top = ($use_separate_remote ? "remotes/$origin" : "heads");
74 my $tag_top = "tags";
76 sub store {
77 my ($sha1, $name, $top) = @_;
78 $name = "$git_dir/refs/$top/$name";
79 mkpath(dirname($name));
80 open O, ">", "$name";
81 print O "$sha1\n";
82 close O;
85 open FH, "<", "$git_dir/CLONE_HEAD";
86 while (<FH>) {
87 my ($sha1, $name) = /^([0-9a-f]{40})\s(.*)$/;
88 next if ($name =~ /\^\173/);
89 if ($name eq "HEAD") {
90 open O, ">", "$git_dir/REMOTE_HEAD";
91 print O "$sha1\n";
92 close O;
93 next;
95 if ($name =~ s/^refs\/heads\///) {
96 store($sha1, $name, $branch_top);
97 next;
99 if ($name =~ s/^refs\/tags\///) {
100 store($sha1, $name, $tag_top);
101 next;
104 close FH;
107 quiet=
108 local=no
109 use_local=no
110 local_shared=no
111 unset template
112 no_checkout=
113 upload_pack=
114 bare=
115 reference=
116 origin=
117 origin_override=
118 use_separate_remote=t
119 depth=
120 while
121 case "$#,$1" in
122 0,*) break ;;
123 *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
124 *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
125 no_checkout=yes ;;
126 *,--na|*,--nak|*,--nake|*,--naked|\
127 *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
128 *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
129 *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
130 local_shared=yes; use_local=yes ;;
131 1,--template) usage ;;
132 *,--template)
133 shift; template="--template=$1" ;;
134 *,--template=*)
135 template="$1" ;;
136 *,-q|*,--quiet) quiet=-q ;;
137 *,--use-separate-remote)
138 # default
139 use_separate_remote=t ;;
140 *,--use-immingled-remote)
141 use_separate_remote= ;;
142 1,--reference) usage ;;
143 *,--reference)
144 shift; reference="$1" ;;
145 *,--reference=*)
146 reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
147 *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
148 case "$2" in
150 usage ;;
151 */*)
152 die "'$2' is not suitable for an origin name"
153 esac
154 git-check-ref-format "heads/$2" ||
155 die "'$2' is not suitable for a branch name"
156 test -z "$origin_override" ||
157 die "Do not give more than one --origin options."
158 origin_override=yes
159 origin="$2"; shift
161 1,-u|1,--upload-pack) usage ;;
162 *,-u|*,--upload-pack)
163 shift
164 upload_pack="--exec=$1" ;;
165 1,--depth) usage;;
166 *,--depth)
167 shift
168 depth="--depth=$1";;
169 *,-*) usage ;;
170 *) break ;;
171 esac
173 shift
174 done
176 repo="$1"
177 test -n "$repo" ||
178 die 'you must specify a repository to clone.'
180 # --bare implies --no-checkout and --use-immingled-remote
181 if test yes = "$bare"
182 then
183 if test yes = "$origin_override"
184 then
185 die '--bare and --origin $origin options are incompatible.'
187 no_checkout=yes
188 use_separate_remote=
191 if test -z "$origin"
192 then
193 origin=origin
196 # Turn the source into an absolute path if
197 # it is local
198 if base=$(get_repo_base "$repo"); then
199 repo="$base"
200 local=yes
203 dir="$2"
204 # Try using "humanish" part of source repo if user didn't specify one
205 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
206 [ -e "$dir" ] && die "destination directory '$dir' already exists."
207 mkdir -p "$dir" &&
208 D=$(cd "$dir" && pwd) &&
209 trap 'err=$?; cd ..; rm -rf "$D"; exit $err' 0
210 case "$bare" in
211 yes)
212 GIT_DIR="$D" ;;
214 GIT_DIR="$D/.git" ;;
215 esac && export GIT_DIR && git-init-db ${template+"$template"} || usage
217 if test -n "$reference"
218 then
219 if test -d "$reference"
220 then
221 if test -d "$reference/.git/objects"
222 then
223 reference="$reference/.git"
225 reference=$(cd "$reference" && pwd)
226 echo "$reference/objects" >"$GIT_DIR/objects/info/alternates"
227 (cd "$reference" && tar cf - refs) |
228 (cd "$GIT_DIR/refs" &&
229 mkdir reference-tmp &&
230 cd reference-tmp &&
231 tar xf -)
232 else
233 die "reference repository '$reference' is not a local directory."
237 rm -f "$GIT_DIR/CLONE_HEAD"
239 # We do local magic only when the user tells us to.
240 case "$local,$use_local" in
241 yes,yes)
242 ( cd "$repo/objects" ) ||
243 die "-l flag seen but repository '$repo' is not local."
245 case "$local_shared" in
247 # See if we can hardlink and drop "l" if not.
248 sample_file=$(cd "$repo" && \
249 find objects -type f -print | sed -e 1q)
251 # objects directory should not be empty since we are cloning!
252 test -f "$repo/$sample_file" || exit
255 if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
256 then
258 fi &&
259 rm -f "$GIT_DIR/objects/sample" &&
260 cd "$repo" &&
261 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
263 yes)
264 mkdir -p "$GIT_DIR/objects/info"
265 echo "$repo/objects" >> "$GIT_DIR/objects/info/alternates"
267 esac
268 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
271 case "$repo" in
272 rsync://*)
273 case "$depth" in
274 "") ;;
275 *) die "shallow over rsync not supported" ;;
276 esac
277 rsync $quiet -av --ignore-existing \
278 --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
279 exit
280 # Look at objects/info/alternates for rsync -- http will
281 # support it natively and git native ones will do it on the
282 # remote end. Not having that file is not a crime.
283 rsync -q "$repo/objects/info/alternates" \
284 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
285 rm -f "$GIT_DIR/TMP_ALT"
286 if test -f "$GIT_DIR/TMP_ALT"
287 then
288 ( cd "$D" &&
289 . git-parse-remote &&
290 resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
291 while read alt
293 case "$alt" in 'bad alternate: '*) die "$alt";; esac
294 case "$quiet" in
295 '') echo >&2 "Getting alternate: $alt" ;;
296 esac
297 rsync $quiet -av --ignore-existing \
298 --exclude info "$alt" "$GIT_DIR/objects" || exit
299 done
300 rm -f "$GIT_DIR/TMP_ALT"
302 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
304 https://*|http://*|ftp://*)
305 case "$depth" in
306 "") ;;
307 *) die "shallow over http or ftp not supported" ;;
308 esac
309 if test -z "@@NO_CURL@@"
310 then
311 clone_dumb_http "$repo" "$D"
312 else
313 die "http transport not supported, rebuild Git with curl support"
317 case "$upload_pack" in
318 '') git-fetch-pack --all -k $quiet $depth "$repo" ;;
319 *) git-fetch-pack --all -k $quiet "$upload_pack" $depth "$repo" ;;
320 esac >"$GIT_DIR/CLONE_HEAD" ||
321 die "fetch-pack from '$repo' failed."
323 esac
325 esac
326 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
328 if test -f "$GIT_DIR/CLONE_HEAD"
329 then
330 # Read git-fetch-pack -k output and store the remote branches.
331 @@PERL@@ -e "$copy_refs" "$GIT_DIR" "$use_separate_remote" "$origin" ||
332 exit
335 cd "$D" || exit
337 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
338 then
339 # Figure out which remote branch HEAD points at.
340 case "$use_separate_remote" in
341 '') remote_top=refs/heads ;;
342 *) remote_top="refs/remotes/$origin" ;;
343 esac
345 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
346 case "$head_sha1" in
347 'ref: refs/'*)
348 # Uh-oh, the remote told us (http transport done against
349 # new style repository with a symref HEAD).
350 # Ideally we should skip the guesswork but for now
351 # opt for minimum change.
352 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
353 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
355 esac
357 # The name under $remote_top the remote HEAD seems to point at.
358 head_points_at=$(
360 echo "master"
361 cd "$GIT_DIR/$remote_top" &&
362 find . -type f -print | sed -e 's/^\.\///'
363 ) | (
364 done=f
365 while read name
367 test t = $done && continue
368 branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
369 if test "$head_sha1" = "$branch_tip"
370 then
371 echo "$name"
372 done=t
374 done
378 # Write out remotes/$origin file, and update our "$head_points_at".
379 case "$head_points_at" in
381 mkdir -p "$GIT_DIR/remotes" &&
382 git-symbolic-ref HEAD "refs/heads/$head_points_at" &&
383 case "$use_separate_remote" in
384 t) origin_track="$remote_top/$head_points_at"
385 git-update-ref HEAD "$head_sha1" ;;
386 *) origin_track="$remote_top/$origin"
387 git-update-ref "refs/heads/$origin" "$head_sha1" ;;
388 esac &&
389 echo >"$GIT_DIR/remotes/$origin" \
390 "URL: $repo
391 Pull: refs/heads/$head_points_at:$origin_track" &&
392 (cd "$GIT_DIR/$remote_top" && find . -type f -print) |
393 while read dotslref
395 name=`expr "$dotslref" : './\(.*\)'`
396 if test "z$head_points_at" = "z$name"
397 then
398 continue
400 if test "$use_separate_remote" = '' &&
401 test "z$origin" = "z$name"
402 then
403 continue
405 echo "Pull: refs/heads/${name}:$remote_top/${name}"
406 done >>"$GIT_DIR/remotes/$origin" &&
407 case "$use_separate_remote" in
409 rm -f "refs/remotes/$origin/HEAD"
410 git-symbolic-ref "refs/remotes/$origin/HEAD" \
411 "refs/remotes/$origin/$head_points_at"
412 esac
413 esac
415 case "$no_checkout" in
417 test "z$quiet" = z && v=-v || v=
418 git-read-tree -m -u $v HEAD HEAD
419 esac
421 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"
423 trap - 0